<!DOCTYPE html>
<html>

<head lang="en">
    <meta charset="UTF-8">
    <title>Acad276 Practical Exam: Search, Results, and Details</title>
    <style>
        h1 {
            margin: auto;
            text-align: center;
            background-color: #900;
            color: #FC0;
            line-height: 60px;
        }
        h2 {
            margin: auto;
            text-align: center;
            padding: 30px;
        }
        .container {
            width: 600px;
            margin: auto;
            border: 1px solid red;
        }
        .label, .input {
            float: left;
            width: 130px;
            margin: 3px;
        }
        .label {
            margin-left: 40px;
        }
        .input>input, .input>select {
            width: 100%;
        }
        .search-submit {
            margin-top: 20px;
            margin-left: 170px;
            width: 80px;
        }
        table {
            margin: auto;
            margin-bottom: 20px;
            width: 80%;
            border-collapse: collapse;
        }
        th, td {
            border: 1px solid #900;
            padding: 10px;
            text-align: center;
        }
        .num-results {
            margin: 20px 10px;
        }
        .nav-link {
            margin: 10px 0px;
            font-size: 14px;
        }
        .details {
            border: 1px solid #990000;
            width: 600px;
            margin: auto;
            margin-top: 20px;
            padding: 20px;
        }
        table img {
            height: 300px;
        }
        img {
            width: 300px;
        }
        .label {
            text-align: right;
            width: 20%;
            padding: 3px 10px 3px;
        }
        .data {
            width: 40%;
        }
    </style>
</head>

<body>

<div class="container">
    <h1>Mobile Devices Database</h1>

    <?php
    $mysql = new mysqli("webdev.iyaserver.com", "dent_guest", "Acad276_Dev2Ex@m", "dent_exam");
    if ($mysql->connect_errno) {
        echo "Failed to connect to MySQL: " . $mysql->connect_error;
        exit();
    }

    if (isset($_GET['device_id'])) {
        $device_id = $mysql->real_escape_string($_GET['device_id']);
        $sql = "SELECT d.*, m.manufacturer, s.system, t.type 
        FROM devices d
        JOIN manufacturers m ON d.manufacturer_id = m.manufacturer_id
        JOIN systems s ON d.system_id = s.system_id
        JOIN types t ON d.type_id = t.type_id
        WHERE d.device_id = '$device_id'";

        $results = $mysql->query($sql);

        if ($results && $results->num_rows > 0) {
            $row = $results->fetch_assoc();
            echo "<div class='details'>
                    <table>
                        <tr>
                            <td rowspan='5' class='img'>";
            if (!empty($row['img_url'])) {
                echo "<img src='" . $row['img_url'] . "' alt='" . $row['name'] . "'>";
            } else {
                echo "<img src='default_image.jpg' alt='Default Image'>";
            }
            echo "</td>
                            <td class='label'>Name:</td>
                            <td class='data'><strong><em>" . $row['name'] . "</em></strong></td>
                        </tr>
                        <tr>
                            <td class='label'>Price:</td>
                            <td><strong>" . $row['price'] . "</strong></td>
                        </tr>
                        <tr>
                            <td class='label'>Manufacturer:</td>
                            <td>" . $row['manufacturer'] . "</td>
                        </tr>
                        <tr>
                            <td class='label'>System:</td>
                            <td>" . $row['system'] . "</td>
                        </tr>
                        <tr>
                            <td class='label'>Type:</td>
                            <td>" . $row['type'] . "</td>
                        </tr>
                    </table>
                  </div>";
        } else {
            echo "Device not found.";
        }

    } elseif ($_SERVER['REQUEST_METHOD'] == 'GET' && !isset($_GET['search'])) {
        ?>


        <!-- Search Form -->
        <h2>Search the Database</h2>
        <form method="get" action="">
            <div class="label">Device Name:</div>
            <div class="input">
                <input type="text" name="device_name"/>
            </div>
            <br clear="all"/>

            <div class="label">Manufacturer:</div>
            <div class="input">
                <select name="manufacturer_id">
                    <option value='all'>All</option>
                    <?php
                    $sql = "SELECT manufacturer_id, manufacturer FROM manufacturers";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        if ($results->num_rows > 0) {
                            while ($row = $results->fetch_assoc()) {
                                echo "<option value='" . $row['manufacturer_id'] . "'>" . $row['manufacturer'] . "</option>";
                            }
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <div class="label">Operating System:</div>
            <div class="input">
                <select name="system_id">
                    <option value='all'>All</option>
                    <?php
                    $sql = "SELECT system_id FROM systems";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        if ($results->num_rows > 0) {
                            while ($row = $results->fetch_assoc()) {
                                echo "<option value='" . $row['system_id'] . "'>" . $row['system_id'] . "</option>";
                            }
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <div class="label">Type:</div>
            <div class="input">
                <select name="type_id">
                    <option value='all'>All</option>
                    <?php
                    $sql = "SELECT type_id type FROM types";
                    $results = $mysql->query($sql);
                    if (!$results) {
                        echo "Error: " . $mysql->error;
                    } else {
                        if ($results->num_rows > 0) {
                            while ($row = $results->fetch_assoc()) {
                                echo "<option value='" . $row['type_id'] . "'>" . $row['type'] . "</option>";
                            }
                        }
                    }
                    ?>
                </select>
            </div>
            <br clear="all"/>

            <input class="search-submit" type="submit" name="search" value="Search"/>
        </form>

        <?php
    } else {
        $sql = "SELECT d.*, m.manufacturer AS manufacturer_name, os.system AS system_name, t.type AS type_name 
                FROM devices d
                JOIN manufacturers m ON d.manufacturer_id = m.manufacturer_id
                JOIN systems os ON d.system_id = os.system_id
                JOIN types t ON d.type_id = t.type_id
                WHERE 1=1";

        if (!empty($_GET['device_name'])) {
            $device_name = $mysql->real_escape_string($_GET['device_name']);
            $sql .= " AND d.name LIKE '%$device_name%'";
        }
        if ($_GET['manufacturer_id'] != 'all') {
            $manufacturer_id = $mysql->real_escape_string($_GET['manufacturer_id']);
            $sql .= " AND d.manufacturer_id = '$manufacturer_id'";
        }
        if ($_GET['system_id'] != 'all') {
            $system_id = $mysql->real_escape_string($_GET['system_id']);
            $sql .= " AND d.system_id = '$system_id'";
        }
        if ($_GET['type_id'] != 'all') {
            $type_id = $mysql->real_escape_string($_GET['type_id']);
            $sql .= " AND d.type_id = '$type_id'";
        }

        $results = $mysql->query($sql);

        if (!$results) {
            echo "Error: " . $mysql->error;
            exit();
        }

        echo "<div class='num-results'>Your search returned <strong>" . $results->num_rows . "</strong> results.</div>";

        if ($results->num_rows > 0) {
            echo "<table>";
            echo "<tr><th>Name</th><th>Price</th><th>Manufacturer</th><th>System</th><th>Type</th></tr>";
            while ($row = $results->fetch_assoc()) {
                echo "<tr>";
                echo "<td><a href='?device_id=" . $row['device_id'] . "'>" . $row['name'] . "</a></td>";
                echo "<td>" . $row['price'] . "</td>";
                echo "<td>" . $row['manufacturer_name'] . "</td>";
                echo "<td>" . $row['system_name'] . "</td>";
                echo "<td>" . $row['type_name'] . "</td>";
                echo "</tr>";
            }
            echo "</table>";
        } else {
            echo "<p>No results found.</p>";
        }
    }
    ?>
</div>

</body>
</html>
